/**
 * Utility method for working with whitelists defined as arrays of strings, where each string is either an absolute
 * matcher, or a prefix matcher (if it has a '*' suffix) or a wildcard matcher (if is a '*' character).
 */
export declare class WhitelistUtils {
    /**
     * Each element in 'pattern' is combined through an OR relationship.
     *
     * Each element in "pattern" is either an:
     * - Absolute (e.g. "images/jpeg")
     * - Prefix (e.g. "images/*")
     * - Wildcard (i.e. '*')
     * Element element in "value" is absolute.
     */
    static intersect(whitelist: string[], values: string[]): boolean;
    static includes(whitelist: string[], value: string): boolean;
    static intersectOrEmpty(whitelist: string[], values: string[]): boolean;
}
