import { DeepUndefinedToNull, UnboxedDto } from "@upload-io/upload-shared-iso";
export declare class IsoObjectUtils {
    static box<TBoxedDto, TUnboxedDto extends UnboxedDto<TBoxedDto> = UnboxedDto<TBoxedDto>>(unboxedDto: TUnboxedDto): TBoxedDto;
    static nullToUndefined<T>(obj: T): DeepUndefinedToNull<T>;
    static fullOuterJoin<K extends string, V>(left: Record<K, V | undefined>, right: Record<K, V | undefined>, reduce: (left: V, right: V) => V): Record<K, V>;
    static unbox<T>(boxedDto: T): DeepUndefinedToNull<T>;
    static undefinedToNull<T>(obj: T): DeepUndefinedToNull<T>;
    private static replace;
}
