const { pathsToModuleNameMapper } = require("ts-jest/utils"); // eslint-disable-line
const { compilerOptions } = require("./tsconfig.json"); // eslint-disable-line
module.exports = {
  verbose: true,
  preset: "ts-jest",
  moduleNameMapper: pathsToModuleNameMapper(compilerOptions.paths, { prefix: "<rootDir>/" }),

  // Enables Babel for Jest.
  transform: {
    "^.+\\.(ts|tsx)?$": "ts-jest",
    "^.+\\.(js|jsx)$": "babel-jest"
  },

  // Allows Babel to transform the '@apidevtools' packages.
  transformIgnorePatterns: ["/node_modules/(?!@apidevtools)"]
};
