import {
  DailyMonthlyBytesDto,
  DailyMonthlyBytesUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/DailyMonthlyBytesDto";
import {
  DailyMonthlyUploadsDto,
  DailyMonthlyUploadsUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/DailyMonthlyUploadsDto";

export interface StorageStatisticsByTimeDto {
  creates: DailyMonthlyBytesDto;
  createsExtended: DailyMonthlyUploadsDto | undefined;
  deletes: DailyMonthlyBytesDto;
}

export interface StorageStatisticsByTimeUnboxedDto {
  creates: DailyMonthlyBytesUnboxedDto;
  createsExtended: DailyMonthlyUploadsUnboxedDto | null;
  deletes: DailyMonthlyBytesUnboxedDto;
}

export namespace CreatesAndDeletesByTimeDto {
  export const empty: StorageStatisticsByTimeDto = {
    creates: DailyMonthlyBytesDto.empty,
    createsExtended: DailyMonthlyUploadsDto.empty,
    deletes: DailyMonthlyBytesDto.empty
  };

  export function combine(
    left: StorageStatisticsByTimeDto,
    right: StorageStatisticsByTimeDto
  ): StorageStatisticsByTimeDto {
    return {
      creates: DailyMonthlyBytesDto.combine(left.creates, right.creates),
      createsExtended: DailyMonthlyUploadsDto.combine(
        left.createsExtended ?? DailyMonthlyUploadsDto.empty,
        right.createsExtended ?? DailyMonthlyUploadsDto.empty
      ),
      deletes: DailyMonthlyBytesDto.combine(left.deletes, right.deletes)
    };
  }
}
