import { IsoObjectUtils } from "@upload-io/upload-shared-iso/common/IsoObjectUtils";
import {
  UploadsAtEpochDto,
  UploadsAtEpochUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/UploadsAtEpochDto";

// 'epochValue' can be epoch month, epoch day, etc.
export interface UploadsByEpochDto {
  [epochValue: string]: UploadsAtEpochDto | undefined;
}

export interface UploadsByEpochUnboxedDto {
  [epochValue: string]: UploadsAtEpochUnboxedDto | null;
}

export namespace UploadsByEpochDto {
  export function combine(left: UploadsByEpochDto, right: UploadsByEpochDto): UploadsByEpochDto {
    return IsoObjectUtils.fullOuterJoin(left, right, UploadsAtEpochDto.combine);
  }
}
